
if(!dojo._hasResource["ibm.widget.InlineError"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
	dojo._hasResource["ibm.widget.InlineError"] = true;
}	

dojo.provide("ibm.widget.InlineError");

dojo.require("ibm.widget._ErrorBase");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuBar");
dojo.require("dijit.MenuItem");
dojo.require("dijit.MenuSeparator");
dojo.require("dijit.PopupMenuBarItem");

dojo.declare("ibm.widget.InlineError",
	[dijit._Widget, dijit._Templated, ibm.widget._ErrorBase],
{
	widgetsInTemplate: true,
	
	templateString: dojo.cache("dijit", "../../edojo/ibm/widget/resources/InlineErrorTemplate.html"),
	
	eid: '',
	content: '',
	stack: '',

	searchCriteria:'',		
	
	url: 'http://www.ibm.com/developerworks/views/rss/customrssatom.jsp?zone_type=AllZones&content_type=AllTypes&search_by=${query}&day=1&month=01&year=2008&max_entries=100&feed_by=rss&ibm-submit=Submit',
	
	maxResults: 5,
	
	showAbstracts: true,
	feedLabel:'Latest articles on this error message',
	
	actionLabel:'',

	helpTitle:'',
	helpHref:'',


	
	_items:'',
	_written: false,
	_menuBar:'',
	
	postCreate: function(){
	 	
		console.info("postCreate()");
	
	 	this._menuBar = new dijit.MenuBar({
	 		className:'utInlineErrorMenuBar'
	 	});
	 	
		console.info("menuBar created");
	    this.feedMenuDiv.appendChild(this._menuBar.domNode);
	    
		this._loadData();
	},
	
	_addHelp: function(){
		if (this.helpHref!=null && this.helpHref!='')
		{
			var menu = new dijit.Menu({});
		    var item =	new dijit.MenuItem({
	            label: '<iframe name="'+this.id+'_help-frame" id="'+this.id+'_help-frame" class="utInlineErrorHelpFrame" frameborder="0" src="'+this.helpHref+'">x</iframe>',
				_onClick: function(){}
	    	});
	    	item.focusNode.setAttribute('class',item.focusNode.getAttribute('class')+' utInlineErrorHelpItem');
		    this._menuBar.addChild(item);
	    
	    
	    
		    var popup =	new dijit.PopupMenuBarItem({
	            	label: this.content,
	            	popup: menu
	    	});
	    	popup.focusNode.setAttribute('class',popup.focusNode.getAttribute('class')+' utInlineErrorHelpMenu');
		    this._menuBar.addChild(popup);
		}
	},
	
	_buildFeedMenu: function(){
	
	 
		var menu = new dijit.Menu({});
        
        
		var itemDisplayLimit = (this._items.length >= this.maxResults) ? this.maxResults : this._items.length;   //Limit item display list to $MaxFeedResults items
		
		for (var i=0;i<itemDisplayLimit;i++)
		{
			var item = new dijit.MenuItem({
	            label: this._items[i].title,
	            link: this._items[i].link,
	            iconClass: 'utInlineErrorFeedItem',
				onClick: function() {
					window.open(this.link);
           		}
	        });
	        item.focusNode.title = this._items[i].description;
	        item.containerNode.innerHTML = '<div class="utInlineErrorFeedTitle">'+item.containerNode.innerHTML+'</div>';
	        
	        if (this.showAbstracts)
	        	item.containerNode.innerHTML +='<div class="utInlineErrorFeedDesc">'+this._items[i].description+'</div>';
	        
	        menu.addChild(item);
	        
	        
//			if (i!=itemDisplayLimit-1)
//				menu.addChild(new dijit.MenuSeparator());
	    } 
	    
	    
	    var popup =	new dijit.PopupMenuBarItem({
            	label: this.feedLabel,
            	popup: menu
    	});
    	popup.focusNode.setAttribute('class',popup.focusNode.getAttribute('class')+' utInlineErrorFeedMenu');
	    	    
	    this._menuBar.addChild(popup);
	},
	
	_loadData: function(){
		var me = this;
		if (this.searchCriteria==null || this.searchCriteria=='')
			this.searchCriteria=this.eid;
		this.loadFeed(
			function(data){
				me._items = data.items;
				me._addHelp();
				if (me._items.length>0)
				{
					me._buildFeedMenu();
				}
				me._createStack();
				
				if (me.helpHref!=null && me.helpHref!='')		
				    me.message.style.display="none";
			},
			function(data){
				me.loader.style.display='none';
			},
			function(data){
				alert("Error: "+data.message);
			},
			this.searchCriteria,
			this.url
		);		
	},
		
	_createStack: function(){
		if (this.stack!='')
		{
		
			var menu = new dijit.Menu({});
			
			menu.addChild(new dijit.MenuItem({
	            label: '<div class="utInlineErrorStackItem"><span>'+this.stack+'</span></div>',
				className: 'utInlineErrorStackItem',
				_onClick: function(){}
	        }));
	        
		    var popup =	new dijit.PopupMenuBarItem({
	            	label: 'Stack Trace',
	            	popup: menu
	    	});
	    	popup.focusNode.setAttribute('class',popup.focusNode.getAttribute('class')+' utInlineErrorStackMenu');
		    this._menuBar.addChild(popup);
		}
	},
	
	addFunction: function(name,id,text)
	{
		this.inherited(arguments);
	
		this.actionButton.style.display="block";
		this.actionButton.href="javascript:"+name+"()";
		this.actionButton.innerHTML=this.actionLabel;
	}
});

