
function initTreeContextMenu() {
	
	var menu = dijit.byId("tree_menu");
	menu.bindDomNode(dojo.byId("tree"));
	
	dojo.connect(menu, "_openMyself", this, function(e) {
		
		var tn = dijit.getEnclosingWidget(e.target);
		
//		POPUP_MENU_SELECTED_ITEM = tn.item;
		POPUP_MENU_SELECTED_TREENODE = tn;
		
		menu.getChildren().forEach(function(i) {
			
			var type = getValue(tn.item, 'type');
			if (i.id == 'addSitePopup') {
				i.domNode.style.display = 'block';
			} else if (i.id == 'editSitePopup') {
				i.domNode.style.display = (tn.item.root || type != 'localsite') ? 'none' : 'block';
			} else if (i.id == 'removeSitePopup') {
				i.domNode.style.display = (tn.item.root || type != 'localsite') ? 'none' : 'block';
//			} else if (i.id == 'removeAllSitesPopup') {
//				i.domNode.style.display = (tn.item.root || IS_REMOVE_SITES_DISABLED) ? 'none' : 'block';
			} else if (i.id == 'installPopup') {
				var isInstalled = getValue(tn.item, 'installed');
				i.domNode.style.display = (tn.item.root || (type == 'category' 
					&& isInstalled == 'true') || IS_TASK_IN_PROGRESS == true || type != 'category') ? 'none' : 'block';
			} else if (i.id == 'installAllPopup') {
				i.domNode.style.display = (tn.item.root || IS_TASK_IN_PROGRESS == true || IS_INSTALL_DISABLED) ? 'none' : 'block';
			} else if (i.id == 'removeTreePopup') {
				var isInstalled = getValue(tn.item, 'installed');
				i.domNode.style.display = (tn.item.root || IS_TASK_IN_PROGRESS == true 
						|| type != 'category' || isInstalled != 'true') ? 'none' : 'block';
			} else if (i.id == 'addFavoritePopup') {
				var favorite = getValue(tn.item, 'favorite');
				i.domNode.style.display = (tn.item.root || type == 'publicsite' || type == 'category' || favorite == 'true') ? 'none' : 'block';
			} else if (i.id == 'removeFavoritePopup') {
				var favorite = getValue(tn.item, 'favorite');
				i.domNode.style.display = (tn.item.root || type == 'publicsite' || type == 'category' || favorite != 'true'/* || type == 'watchedsite'*/) ? 'none' : 'block';
			}
		});
	});
}

function initGridContextMenu() {
	
	var menu = dijit.byId("grid_menu");
	
	// when we right-click anywhere on the grid, make sure we open the menu
	var installedGrid = dijit.byId("installedGrid");
	installedGrid.onRowContextMenu = function(e) {
		menu._openMyself(e); // spot of bother
	};
	
	dojo.connect(menu, "_openMyself", this, function(e) {
		
		POPUP_MENU_SELECTED_ITEM = installedGridStore._arrayOfTopLevelItems[e.rowIndex];
		
		installedGrid.selection.clear();
		installedGrid.selection.setSelected(e.rowIndex, true);
		
		menu.getChildren().forEach(function(i) {
			
			var itemUpdate = POPUP_MENU_SELECTED_ITEM.update[0];
			if (i.id == 'removePopup') {
//				i.setDisabled(IS_TASK_IN_PROGRESS == true);
				i.domNode.style.display = (IS_TASK_IN_PROGRESS == true) ? 'none' : 'block';
			} else if (i.id == 'removeAllPopup') {
//				i.setDisabled(IS_TASK_IN_PROGRESS == true || IS_REMOVE_DISABLED);
				i.domNode.style.display = (IS_TASK_IN_PROGRESS == true || IS_REMOVE_DISABLED) ? 'none' : 'block';
			} else if (i.id == 'updatePopup') {
//				i.setDisabled(IS_TASK_IN_PROGRESS == true || itemUpdate != "true");
				i.domNode.style.display = (IS_TASK_IN_PROGRESS == true || itemUpdate != "true") ? 'none' : 'block';
			} else if (i.id == 'updateAllPopup') {
//				i.setDisabled(IS_TASK_IN_PROGRESS == true || IS_UPDATE_DISABLED);
				i.domNode.style.display = (IS_TASK_IN_PROGRESS == true || IS_UPDATE_DISABLED) ? 'none' : 'block';
			}
		});
	});
}
